Loading...
Searching...
No Matches
casacore::TableExprFuncNode Class Reference
tables package (libcasa_tables) » TaQL_module » TaQL_module_internal_classes

More...

`#include <ExprFuncNode.h>`

## Public Types

enum

FunctionType {
piFUNC ,
eFUNC ,
cFUNC ,
near2FUNC ,
near3FUNC ,
nearabs2FUNC ,
nearabs3FUNC ,
sinFUNC ,
sinhFUNC ,
cosFUNC ,
coshFUNC ,
expFUNC ,
logFUNC ,
log10FUNC ,
sqrtFUNC ,
powFUNC ,
conjFUNC ,
squareFUNC ,
cubeFUNC ,
minFUNC ,
maxFUNC ,
normFUNC ,
absFUNC ,
argFUNC ,
realFUNC ,
imagFUNC ,
intFUNC ,
asinFUNC ,
acosFUNC ,
atanFUNC ,
atan2FUNC ,
tanFUNC ,
tanhFUNC ,
signFUNC ,
roundFUNC ,
floorFUNC ,
ceilFUNC ,
fmodFUNC ,
complexFUNC ,
arrsumFUNC ,
arrsumsFUNC ,
runsumFUNC ,
boxsumFUNC ,
arrproductFUNC ,
arrproductsFUNC ,
runproductFUNC ,
boxproductFUNC ,
arrsumsqrFUNC ,
arrsumsqrsFUNC ,
runsumsqrFUNC ,
boxsumsqrFUNC ,
arrminFUNC ,
arrminsFUNC ,
runminFUNC ,
boxminFUNC ,
arrmaxFUNC ,
arrmaxsFUNC ,
runmaxFUNC ,
boxmaxFUNC ,
arrmeanFUNC ,
arrmeansFUNC ,
runmeanFUNC ,
boxmeanFUNC ,
arrvariance0FUNC ,
arrvariances0FUNC ,
runvariance0FUNC ,
boxvariance0FUNC ,
arrvariance1FUNC ,
arrvariances1FUNC ,
runvariance1FUNC ,
boxvariance1FUNC ,
arrstddev0FUNC ,
arrstddevs0FUNC ,
runstddev0FUNC ,
boxstddev0FUNC ,
arrstddev1FUNC ,
arrstddevs1FUNC ,
runstddev1FUNC ,
boxstddev1FUNC ,
arravdevFUNC ,
arravdevsFUNC ,
runavdevFUNC ,
boxavdevFUNC ,
arrrmsFUNC ,
arrrmssFUNC ,
runrmsFUNC ,
boxrmsFUNC ,
arrmedianFUNC ,
arrmediansFUNC ,
runmedianFUNC ,
boxmedianFUNC ,
arrfractileFUNC ,
arrfractilesFUNC ,
runfractileFUNC ,
boxfractileFUNC ,
arranyFUNC ,
arranysFUNC ,
runanyFUNC ,
boxanyFUNC ,
arrallFUNC ,
arrallsFUNC ,
runallFUNC ,
boxallFUNC ,
arrntrueFUNC ,
arrntruesFUNC ,
runntrueFUNC ,
boxntrueFUNC ,
arrnfalseFUNC ,
arrnfalsesFUNC ,
runnfalseFUNC ,
boxnfalseFUNC ,
arrayFUNC ,
transposeFUNC ,
areverseFUNC ,
resizeFUNC ,
diagonalFUNC ,
isnanFUNC ,
isinfFUNC ,
isfiniteFUNC ,
isdefFUNC ,
isnullFUNC ,
iscolFUNC ,
iskeyFUNC ,
ndimFUNC ,
nelemFUNC ,
shapeFUNC ,
strlengthFUNC ,
upcaseFUNC ,
downcaseFUNC ,
capitalizeFUNC ,
sreverseFUNC ,
trimFUNC ,
ltrimFUNC ,
rtrimFUNC ,
substrFUNC ,
replaceFUNC ,
regexFUNC ,
patternFUNC ,
sqlpatternFUNC ,
datetimeFUNC ,
mjdtodateFUNC ,
mjdFUNC ,
dateFUNC ,
timeFUNC ,
yearFUNC ,
monthFUNC ,
dayFUNC ,
cmonthFUNC ,
weekdayFUNC ,
cdowFUNC ,
weekFUNC ,
ctodFUNC ,
cdateFUNC ,
ctimeFUNC ,
stringFUNC ,
hmsFUNC ,
dmsFUNC ,
hdmsFUNC ,
randFUNC ,
rownrFUNC ,
rowidFUNC ,
iifFUNC ,
angdistFUNC ,
angdistxFUNC ,
conesFUNC ,
cones3FUNC ,
anyconeFUNC ,
anycone3FUNC ,
findconeFUNC ,
findcone3FUNC ,
normangleFUNC ,
boolFUNC ,
nullarrayFUNC ,
marrayFUNC ,
arrdataFUNC ,
arrmaskFUNC ,
negatemaskFUNC ,
replmaskedFUNC ,
replunmaskedFUNC ,
arrflatFUNC ,
FirstAggrFunc ,
countallFUNC ,
gcountFUNC ,
gfirstFUNC ,
glastFUNC ,
gminFUNC ,
gmaxFUNC ,
gsumFUNC ,
gproductFUNC ,
gsumsqrFUNC ,
gmeanFUNC ,
gvariance0FUNC ,
gvariance1FUNC ,
gstddev0FUNC ,
gstddev1FUNC ,
grmsFUNC ,
ganyFUNC ,
gallFUNC ,
gntrueFUNC ,
gnfalseFUNC ,
FirstAggrArrayFunc ,
gminsFUNC ,
gmaxsFUNC ,
gsumsFUNC ,
gproductsFUNC ,
gsumsqrsFUNC ,
gmeansFUNC ,
gvariances0FUNC ,
gvariances1FUNC ,
gstddevs0FUNC ,
gstddevs1FUNC ,
grmssFUNC ,
ganysFUNC ,
gallsFUNC ,
gntruesFUNC ,
gnfalsesFUNC ,
LastAggrArrayFunc ,
ghistFUNC ,
gaggrFUNC ,
growidFUNC ,
gmedianFUNC ,
gfractileFUNC ,
gexpridFUNC ,
NRFUNC
}

Public Types inherited from casacore::TableExprNodeRep
enum | NodeDataType { NTBool , NTInt , NTDouble , NTComplex , NTString , NTRegex , NTDate , NTReal , NTDouCom , NTNumeric , NTAny }
| Define the data types of a node. More...
enum | ValueType { VTScalar , VTArray , VTRecord , VTSetElem , VTSet , VTIndex }
| Define the value types. More...
enum | OperType { OtPlus , OtMinus , OtTimes , OtDivide , OtModulo , OtBitAnd , OtBitOr , OtBitXor , OtBitNegate , OtEQ , OtGE , OtGT , OtNE , OtIN , OtAND , OtOR , OtNOT , OtMIN , OtColumn , OtField , OtLiteral , OtFunc , OtSlice , OtUndef , OtRownr , OtRandom }
| Define the operator types. More...
enum | ArgType { NoArr , ArrArr , ArrSca , ScaArr }
| Define the value types of the 2 arguments when arrays are involved. More...
enum | ExprType { Constant , Variable }
| Define (sub-)expression type. More...

## Public Member Functions

| TableExprFuncNode (FunctionType, NodeDataType, ValueType, const TableExprNodeSet &source, const vector< TENShPtr > &nodes, const Block< Int > &dtypeOper, const TableExprInfo &=TableExprInfo())
| Constructor.
| ~TableExprFuncNode ()
| Destructor.
Bool | getBool (const TableExprId &id)
| 'get' Functions to get the desired result of a function
Int64 | getInt (const TableExprId &id)
Double | getDouble (const TableExprId &id)
DComplex | getDComplex (const TableExprId &id)
String | getString (const TableExprId &id)
TaqlRegex | getRegex (const TableExprId &id)
MVTime | getDate (const TableExprId &id)
void | fillUnits ()
| Fill the result unit in the node.
void | fillChildNodes (const vector< TENShPtr > &nodes, const Block< Int > &dtypeOper)
| Link the children to the node and convert the children to constants if possible.
Double | getScale () const
| Get possible unit scale factor (needed for sqrt).
const std::vector< TENShPtr > & | operands () const
| Some functions to be used by TableExprNodeFuncArray.
std::vector< TENShPtr > & | rwOperands ()
FunctionType | funcType () const
NodeDataType | argDataType () const
Public Member Functions inherited from casacore::TableExprNodeMulti
| TableExprNodeMulti (NodeDataType, ValueType, OperType, const TableExprNodeRep &source)
| Constructor.
| ~TableExprNodeMulti () override=default
| Destructor.
void | show (ostream &, uInt indent) const override
| Show the expression tree.
void | flattenTree (std::vector< TableExprNodeRep * > &) override
| Flatten the node tree by adding the node and its children to the vector.
const std::vector< TENShPtr > & | getChildren () const
| Get the child nodes.
Public Member Functions inherited from casacore::TableExprNodeRep
| TableExprNodeRep (NodeDataType, ValueType, OperType, ArgType, ExprType, Int ndim, const IPosition &shape)
| Construct a node.
| TableExprNodeRep (NodeDataType, ValueType, OperType, ExprType)
| This constructor is called from the derived TableExprNodeRep.
| TableExprNodeRep (const TableExprNodeRep &)=default
| Copy constructor.
TableExprNodeRep & | operator= (const TableExprNodeRep &)=delete
| Assign to a TableExprNodeRep cannot be done.
virtual | ~TableExprNodeRep ()=default
| The destructor deletes all the underlying TableExprNode objects.
virtual Bool | isAggregate () const
| Is the node an aggegation node.
virtual TableExprInfo | getTableInfo () const
| Get the table info.
virtual void | optimize ()
| Try to optimize the node (meant for the right hand of the IN operator).
virtual void | disableApplySelection ()
| Do not apply the selection.
virtual void | applySelection (const Vector< rownr_t > &rownrs)
| Re-create the column object for a selection of rows.
virtual Double | getUnitFactor () const
| Get the unit conversion factor.
virtual std::shared_ptr< TableExprGroupFuncBase > | makeGroupAggrFunc ()
| Create the correct immediate aggregate function object.
virtual Bool | isLazyAggregate () const
| Is the aggregate function a lazy or an immediate one?
virtual MArray< Bool > | getArrayBool (const TableExprId &id)
| Get an array value for this node in the given row.
virtual MArray< Int64 > | getArrayInt (const TableExprId &id)
virtual MArray< Double > | getArrayDouble (const TableExprId &id)
virtual MArray< DComplex > | getArrayDComplex (const TableExprId &id)
virtual MArray< String > | getArrayString (const TableExprId &id)
virtual MArray< MVTime > | getArrayDate (const TableExprId &id)
void | get (const TableExprId &id, Bool &value)
| General get functions for template purposes.
void | get (const TableExprId &id, Int64 &value)
void | get (const TableExprId &id, Double &value)
void | get (const TableExprId &id, DComplex &value)
void | get (const TableExprId &id, MVTime &value)
void | get (const TableExprId &id, String &value)
void | get (const TableExprId &id, MArray< Bool > &value)
void | get (const TableExprId &id, MArray< Int64 > &value)
void | get (const TableExprId &id, MArray< Double > &value)
void | get (const TableExprId &id, MArray< DComplex > &value)
void | get (const TableExprId &id, MArray< MVTime > &value)
void | get (const TableExprId &id, MArray< String > &value)
MArray< Bool > | getBoolAS (const TableExprId &id)
| Get a value as an array, even it it is a scalar.
MArray< Int64 > | getIntAS (const TableExprId &id)
MArray< Double > | getDoubleAS (const TableExprId &id)
MArray< DComplex > | getDComplexAS (const TableExprId &id)
MArray< String > | getStringAS (const TableExprId &id)
MArray< MVTime > | getDateAS (const TableExprId &id)
virtual Bool | contains (const TableExprId &id, Bool value)
| Does a set or array contain the value?
virtual Bool | contains (const TableExprId &id, Int64 value)
virtual Bool | contains (const TableExprId &id, Double value)
virtual Bool | contains (const TableExprId &id, DComplex value)
virtual Bool | contains (const TableExprId &id, String value)
virtual Bool | contains (const TableExprId &id, MVTime value)
virtual MArray< Bool > | contains (const TableExprId &id, const MArray< Bool > &value)
virtual MArray< Bool > | contains (const TableExprId &id, const MArray< Int64 > &value)
virtual MArray< Bool > | contains (const TableExprId &id, const MArray< Double > &value)
virtual MArray< Bool > | contains (const TableExprId &id, const MArray< DComplex > &value)
virtual MArray< Bool > | contains (const TableExprId &id, const MArray< String > &value)
virtual MArray< Bool > | contains (const TableExprId &id, const MArray< MVTime > &value)
rownr_t | nrow ()
| Get the number of rows in the table associated with this expression.
virtual Bool | getColumnDataType (DataType &) const
| Get the data type of the column.
virtual Array< Bool > | getColumnBool (const Vector< rownr_t > &rownrs)
| Get the value of the expression evaluated for the entire column.
virtual Array< uChar > | getColumnuChar (const Vector< rownr_t > &rownrs)
virtual Array< Short > | getColumnShort (const Vector< rownr_t > &rownrs)
virtual Array< uShort > | getColumnuShort (const Vector< rownr_t > &rownrs)
virtual Array< Int > | getColumnInt (const Vector< rownr_t > &rownrs)
virtual Array< uInt > | getColumnuInt (const Vector< rownr_t > &rownrs)
virtual Array< Int64 > | getColumnInt64 (const Vector< rownr_t > &rownrs)
virtual Array< Float > | getColumnFloat (const Vector< rownr_t > &rownrs)
virtual Array< Double > | getColumnDouble (const Vector< rownr_t > &rownrs)
virtual Array< Complex > | getColumnComplex (const Vector< rownr_t > &rownrs)
virtual Array< DComplex > | getColumnDComplex (const Vector< rownr_t > &rownrs)
virtual Array< String > | getColumnString (const Vector< rownr_t > &rownrs)
virtual void | ranges (Block< TableExprRange > &)
| Convert the tree to a number of range vectors which at least select the same things.
NodeDataType | dataType () const
| Get the data type of the derived TableExprNode object.
Bool | isReal () const
| Is the data type real (i.e., integer or double)?
ValueType | valueType () const
| Get the value type.
void | setValueType (ValueType vtype)
| Set the value type.
OperType | operType () const
| Get the operator type.
ExprType | exprType () const
| Get the expression type.
Bool | isConstant () const
| Is the expression a constant?
const Unit & | unit () const
| Get the unit.
void | setUnit (const Unit &unit)
| Set the unit.
const Record & | attributes () const
| Get the attributes.
void | setAttributes (const Record &)
| Set the attributes.
Int | ndim () const
| Get the fixed dimensionality (same for all rows).
const IPosition & | shape () const
| Get the fixed shape (same for all rows).
const IPosition & | shape (const TableExprId &id)
| Get the shape for the given row.
virtual Bool | isDefined (const TableExprId &id)
| Is the value in the given row defined?
virtual void | adaptSetUnits (const Unit &)
| Let a set node convert itself to the given unit.

## Static Public Member Functions

static NodeDataType | checkOperands (Block< Int > &dtypeOper, ValueType &resVT, Block< Int > &vtypeOper, FunctionType, std::vector< TENShPtr > &)
| Check the data and value types of the operands.
static void | getPrintFormat (String &fmt, Int &width, Int &prec, const std::vector< TENShPtr > &operands, const TableExprId &id)
| Get the possible print format, width, and/or precision.
static String | stringDT (const MVTime &dt, Int prec, MVTime::formatTypes)
| Convert the date and/or time to a string.
static String | stringDateTime (const MVTime &dt, Int prec)
static String | stringDate (const MVTime &dt)
static String | stringTime (const MVTime &dt, Int prec)
static String | stringValue (Bool val, const String &fmt, Int width)
| Convert a value to a string.
static String | stringValue (Int64 val, const String &fmt, Int width)
static String | stringValue (Double val, const String &fmt, Int width, Int prec, const std::pair< int, int > &mvFormat, const Unit &unit)
static String | stringValue (const DComplex &val, const String &fmt, Int width, Int prec)
static String | stringValue (const String &val, const String &fmt, Int width)
static String | stringValue (const MVTime &val, const String &fmt, Int width, const std::pair< int, int > &mvFormat)
static String | stringAngle (double val, Int prec, MVAngle::formatTypes type)
| Convert angle to a string (hms or dms).
static String | stringHMS (double val, Int prec)
static String | stringDMS (double val, Int prec)
static std::pair< int, int > | getMVFormat (const String &fmt)
| Get the MVTime/Angle format and optional precision.
static double | angdist (double ra1, double dec1, double ra2, double dec2)
| Get the angular distance between two positions on a sphere.
static Int64 | string2Int (const String &)
| Read a string as an integer, double, complex or bool.
static Double | string2Real (const String &)
static DComplex | string2Complex (const String &)
static Bool | string2Bool (const String &)
Static Public Member Functions inherited from casacore::TableExprNodeMulti
static uInt | checkNumOfArg (uInt low, uInt high, const std::vector< TENShPtr > &nodes)
| Check number of arguments low <= number_of_args <= high It throws an exception if wrong number of arguments.
static NodeDataType | checkDT (Block< Int > &dtypeOper, NodeDataType dtIn, NodeDataType dtOut, const std::vector< TENShPtr > &nodes, Bool dateConv=True)
| Check datatype of nodes and return output type.
Static Public Member Functions inherited from casacore::TableExprNodeRep
static TENShPtr | replaceConstNode (const TENShPtr &node)
| Replace a node with a constant expression by node with its value.
static void | createRange (Block< TableExprRange > &, TableExprNodeColumn *, Double start, Double end)
| Create a range object from a column and an interval.
static void | createRange (Block< TableExprRange > &)
| Create a empty range object.
static String | typeString (NodeDataType)
| Convert a NodeDataType to a string.
static String | typeString (ValueType)
| Convert a ValueType to a string.

## Private Member Functions

void | tryToConst ()
| Try if the function gives a constant result.

## Static Private Member Functions

static const Unit & | makeEqualUnits (std::vector< TENShPtr > &nodes, uInt starg, uInt endarg)
| Make the units of nodes from starg till endarg equal.

## Private Attributes

FunctionType | funcType_p
NodeDataType | argDataType_p
Double | scale_p
Table | table_p
| (needed for sqrt)

## Additional Inherited Members

Protected Member Functions inherited from casacore::TableExprNodeRep
virtual const IPosition & | getShape (const TableExprId &id)
| Get the shape for the given row.
void | fillExprType (const TableExprNodeRep *node)
| Set expression type to Variable if node is Variable.
Static Protected Member Functions inherited from casacore::TableExprNodeRep
static TENShPtr | convertNode (const TENShPtr &thisNode, Bool convertConstType)
| If the node is constant, it is evaluated and replaced by the appropriate TableExprNodeConst object.
Protected Attributes inherited from casacore::TableExprNodeMulti
std::vector< TENShPtr > | operands_p
Protected Attributes inherited from casacore::TableExprNodeRep
NodeDataType | dtype_p
ValueType | vtype_p
OperType | optype_p
ArgType | argtype_p
ExprType | exprtype_p
Int | ndim_p
IPosition | shape_p
Unit | unit_p
Record | attributes_p

## Detailed Description

Class representing a function in table select expression

### Intended use:

Internal

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25

### Prerequisite

- TableExprNodeMulti

### Synopsis

This class represents a function in a table select tree. The rownumber function is represented by class TableExprNodeRownr. The rowid function is represented by class TableExprNodeRowid. The rand function is represented by class TableExprNodeRandom.

When one wants to add a function to the table selection grammar, the following has to be done:

- Add the function to the enum below.
- Implement the function in the get functions in ExprFuncNode(Array).cc.
- Implement the function in the checkOperands in ExprFuncNode.cc.
- Declare and define the function in ExprNode.h (for C++ binding).
- Add the function to findFunc in TableParse.cc (for TaQL).

Definition at line 75 of file ExprFuncNode.h.

## Member Enumeration Documentation

## FunctionType

enum casacore::TableExprFuncNode::FunctionType

Enumerator
piFUNC |
eFUNC |
cFUNC |
near2FUNC | for Int, or Double or Complex returning Bool (2 is with default tolerance)
near3FUNC |
nearabs2FUNC |
nearabs3FUNC |
sinFUNC | for Int, Double or DComplex returning Double or Complex
sinhFUNC |
cosFUNC |
coshFUNC |
expFUNC |
logFUNC |
log10FUNC |
sqrtFUNC |
powFUNC |
conjFUNC |
squareFUNC | for Int, Double or DComplex returning Int, Double or Complex
cubeFUNC |
minFUNC |
maxFUNC |
normFUNC | for Int, Double or DComplex returning Int or Double
absFUNC |
argFUNC | for Int, Double or DComplex returning Double
realFUNC | for Int, Double, DComplex, Bool or String returning Double
imagFUNC | for Double or DComplex returning Double
intFUNC | for Int, Double, Bool or String returning Int (using floor)
asinFUNC | for Int, Double or Complex returning Double or Complex
acosFUNC |
atanFUNC |
atan2FUNC |
tanFUNC |
tanhFUNC |
signFUNC | for Int or Double returning Int or Double
roundFUNC |
floorFUNC |
ceilFUNC |
fmodFUNC |
complexFUNC | for DComplex or String returning DComplex
arrsumFUNC | for Int, Double or Complex array returning the same
arrsumsFUNC |
runsumFUNC |
boxsumFUNC |
arrproductFUNC |
arrproductsFUNC |
runproductFUNC |
boxproductFUNC |
arrsumsqrFUNC |
arrsumsqrsFUNC |
runsumsqrFUNC |
boxsumsqrFUNC |
arrminFUNC | for Int or Double array returning Int or Double
arrminsFUNC |
runminFUNC |
boxminFUNC |
arrmaxFUNC |
arrmaxsFUNC |
runmaxFUNC |
boxmaxFUNC |
arrmeanFUNC | for Int or Double array returning Double
arrmeansFUNC |
runmeanFUNC |
boxmeanFUNC |
arrvariance0FUNC |
arrvariances0FUNC |
runvariance0FUNC |
boxvariance0FUNC |
arrvariance1FUNC |
arrvariances1FUNC |
runvariance1FUNC |
boxvariance1FUNC |
arrstddev0FUNC |
arrstddevs0FUNC |
runstddev0FUNC |
boxstddev0FUNC |
arrstddev1FUNC |
arrstddevs1FUNC |
runstddev1FUNC |
boxstddev1FUNC |
arravdevFUNC |
arravdevsFUNC |
runavdevFUNC |
boxavdevFUNC |
arrrmsFUNC |
arrrmssFUNC |
runrmsFUNC |
boxrmsFUNC |
arrmedianFUNC |
arrmediansFUNC |
runmedianFUNC |
boxmedianFUNC |
arrfractileFUNC |
arrfractilesFUNC |
runfractileFUNC |
boxfractileFUNC |
arranyFUNC | for Bool array returning Bool
arranysFUNC |
runanyFUNC |
boxanyFUNC |
arrallFUNC |
arrallsFUNC |
runallFUNC |
boxallFUNC |
arrntrueFUNC | for Bool array returning Int scalar
arrntruesFUNC |
runntrueFUNC |
boxntrueFUNC |
arrnfalseFUNC |
arrnfalsesFUNC |
runnfalseFUNC |
boxnfalseFUNC |
arrayFUNC | for any type returning array of that type
transposeFUNC |
areverseFUNC |
resizeFUNC |
diagonalFUNC |
isnanFUNC | for Int, Double or DComplex array returning Bool
isinfFUNC |
isfiniteFUNC |
isdefFUNC | for any array returning Bool scalar
isnullFUNC |
iscolFUNC |
iskeyFUNC |
ndimFUNC | for any array returning Int scalar
nelemFUNC |
shapeFUNC | for any array returning Int array
strlengthFUNC | for String
upcaseFUNC |
downcaseFUNC |
capitalizeFUNC |
sreverseFUNC |
trimFUNC |
ltrimFUNC |
rtrimFUNC |
substrFUNC |
replaceFUNC |
regexFUNC |
patternFUNC |
sqlpatternFUNC |
datetimeFUNC | for Date
mjdtodateFUNC |
mjdFUNC |
dateFUNC |
timeFUNC |
yearFUNC |
monthFUNC |
dayFUNC |
cmonthFUNC |
weekdayFUNC |
cdowFUNC |
weekFUNC |
ctodFUNC |
cdateFUNC |
ctimeFUNC |
stringFUNC | return values as strings
hmsFUNC | return angles as hms strings
dmsFUNC | return angles as dms strings
hdmsFUNC | return angles as hms/dms strings
randFUNC | special function returning a random Double number
rownrFUNC | special function returning Int row number
rowidFUNC | special function returning Int row id (meant for GIVING)
iifFUNC | special function resembling if statement
angdistFUNC | angular distance returning radians
angdistxFUNC |
conesFUNC | cone search functions, implemented in derived class
cones3FUNC |
anyconeFUNC |
anycone3FUNC |
findconeFUNC |
findcone3FUNC |
normangleFUNC | normalize angle between -pi and pi
boolFUNC | for Int, Double, Complex or String returning Bool
nullarrayFUNC | masked array functions
marrayFUNC |
arrdataFUNC |
arrmaskFUNC |
negatemaskFUNC |
replmaskedFUNC |
replunmaskedFUNC |
arrflatFUNC |
FirstAggrFunc |
countallFUNC |
gcountFUNC |
gfirstFUNC |
glastFUNC |
gminFUNC |
gmaxFUNC |
gsumFUNC |
gproductFUNC |
gsumsqrFUNC |
gmeanFUNC |
gvariance0FUNC |
gvariance1FUNC |
gstddev0FUNC |
gstddev1FUNC |
grmsFUNC |
ganyFUNC |
gallFUNC |
gntrueFUNC |
gnfalseFUNC |
FirstAggrArrayFunc |
gminsFUNC |
gmaxsFUNC |
gsumsFUNC |
gproductsFUNC |
gsumsqrsFUNC |
gmeansFUNC |
gvariances0FUNC |
gvariances1FUNC |
gstddevs0FUNC |
gstddevs1FUNC |
grmssFUNC |
ganysFUNC |
gallsFUNC |
gntruesFUNC |
gnfalsesFUNC |
LastAggrArrayFunc |
ghistFUNC |
gaggrFUNC |
growidFUNC |
gmedianFUNC |
gfractileFUNC |
gexpridFUNC |
NRFUNC |

Definition at line 79 of file ExprFuncNode.h.

## Constructor & Destructor Documentation

## TableExprFuncNode()

casacore::TableExprFuncNode::TableExprFuncNode | ( | FunctionType | ,
|  | NodeDataType | ,
|  | ValueType | ,
|  | const TableExprNodeSet & | source,
|  | const vector< TENShPtr > & | nodes,
|  | const Block< Int > & | dtypeOper,
|  | const TableExprInfo & | = TableExprInfo() )

Constructor.

## ~TableExprFuncNode()

casacore::TableExprFuncNode::~TableExprFuncNode | ( |  | ) |

Destructor.

## Member Function Documentation

## angdist()

double casacore::TableExprFuncNode::angdist | ( | double | ra1,
|  | double | dec1,
|  | double | ra2,
|  | double | dec2 )

inline static

Get the angular distance between two positions on a sphere.

Definition at line 449 of file ExprFuncNode.h.

References casacore::acos(), casacore::cos(), and casacore::sin().

## argDataType()

NodeDataType casacore::TableExprFuncNode::argDataType | ( |  | ) | const

inline

Definition at line 400 of file ExprFuncNode.h.

References argDataType_p.

## checkOperands()

NodeDataType casacore::TableExprFuncNode::checkOperands | ( | Block< Int > & | dtypeOper,
|  | ValueType & | resVT,
|  | Block< Int > & | vtypeOper,
|  | FunctionType | ,
|  | std::vector< TENShPtr > & | )

static

Check the data and value types of the operands.

It sets the exptected data and value types of the operands. Set the value type of the function result and returns the data type of the function result.

## fillChildNodes()

void casacore::TableExprFuncNode::fillChildNodes | ( | const vector< TENShPtr > & | nodes,
|  | const Block< Int > & | dtypeOper )

Link the children to the node and convert the children to constants if possible.

## fillUnits()

void casacore::TableExprFuncNode::fillUnits | ( |  | ) |

Fill the result unit in the node.

Adapt the children nodes if their units need to be converted. It returns a possible scale factor in case result unit is SI (for sqrt).

## funcType()

FunctionType casacore::TableExprFuncNode::funcType | ( |  | ) | const

inline

Definition at line 398 of file ExprFuncNode.h.

References funcType_p.

## getBool()

Bool casacore::TableExprFuncNode::getBool | ( | const TableExprId & | id | ) |

virtual

'get' Functions to get the desired result of a function

Reimplemented from casacore::TableExprNodeRep.

## getDate()

MVTime casacore::TableExprFuncNode::getDate | ( | const TableExprId & | id | ) |

virtual

Reimplemented from casacore::TableExprNodeRep.

## getDComplex()

DComplex casacore::TableExprFuncNode::getDComplex | ( | const TableExprId & | id | ) |

virtual

Reimplemented from casacore::TableExprNodeRep.

## getDouble()

Double casacore::TableExprFuncNode::getDouble | ( | const TableExprId & | id | ) |

virtual

Reimplemented from casacore::TableExprNodeRep.

## getInt()

Int64 casacore::TableExprFuncNode::getInt | ( | const TableExprId & | id | ) |

virtual

Reimplemented from casacore::TableExprNodeRep.

## getMVFormat()

std::pair< int, int > casacore::TableExprFuncNode::getMVFormat | ( | const String & | fmt | ) |

static

Get the MVTime/Angle format and optional precision.

0,0 is returned if empty or unknown format.

## getPrintFormat()

void casacore::TableExprFuncNode::getPrintFormat | ( | String & | fmt,
|  | Int & | width,
|  | Int & | prec,
|  | const std::vector< TENShPtr > & | operands,
|  | const TableExprId & | id )

static

Get the possible print format, width, and/or precision.

References operands().

## getRegex()

TaqlRegex casacore::TableExprFuncNode::getRegex | ( | const TableExprId & | id | ) |

virtual

Reimplemented from casacore::TableExprNodeRep.

## getScale()

Double casacore::TableExprFuncNode::getScale | ( |  | ) | const

inline

Get possible unit scale factor (needed for sqrt).

Definition at line 389 of file ExprFuncNode.h.

References scale_p.

## getString()

String casacore::TableExprFuncNode::getString | ( | const TableExprId & | id | ) |

virtual

Reimplemented from casacore::TableExprNodeRep.

## makeEqualUnits()

const Unit & casacore::TableExprFuncNode::makeEqualUnits | ( | std::vector< TENShPtr > & | nodes,
|  | uInt | starg,
|  | uInt | endarg )

static private

Make the units of nodes from starg till endarg equal.

Return the unit found.

## operands()

const std::vector< TENShPtr > & casacore::TableExprFuncNode::operands | ( |  | ) | const

inline

Some functions to be used by TableExprNodeFuncArray.

Definition at line 394 of file ExprFuncNode.h.

References casacore::TableExprNodeMulti::operands_p.

Referenced by getPrintFormat(), and casacore::TableExprAggrNode::operand().

## rwOperands()

std::vector< TENShPtr > & casacore::TableExprFuncNode::rwOperands | ( |  | ) |

inline

Definition at line 396 of file ExprFuncNode.h.

References casacore::TableExprNodeMulti::operands_p.

## string2Bool()

Bool casacore::TableExprFuncNode::string2Bool | ( | const String & |  | ) |

static

## string2Complex()

DComplex casacore::TableExprFuncNode::string2Complex | ( | const String & |  | ) |

static

## string2Int()

Int64 casacore::TableExprFuncNode::string2Int | ( | const String & |  | ) |

static

Read a string as an integer, double, complex or bool.

## string2Real()

Double casacore::TableExprFuncNode::string2Real | ( | const String & |  | ) |

static

## stringAngle()

String casacore::TableExprFuncNode::stringAngle | ( | double | val,
|  | Int | prec,
|  | MVAngle::formatTypes | type )

static

Convert angle to a string (hms or dms).

## stringDate()

String casacore::TableExprFuncNode::stringDate | ( | const MVTime & | dt | ) |

static

## stringDateTime()

String casacore::TableExprFuncNode::stringDateTime | ( | const MVTime & | dt,
|  | Int | prec )

static

## stringDMS()

String casacore::TableExprFuncNode::stringDMS | ( | double | val,
|  | Int | prec )

static

## stringDT()

String casacore::TableExprFuncNode::stringDT | ( | const MVTime & | dt,
|  | Int | prec,
|  | MVTime::formatTypes | )

static

Convert the date and/or time to a string.

## stringHMS()

String casacore::TableExprFuncNode::stringHMS | ( | double | val,
|  | Int | prec )

static

## stringTime()

String casacore::TableExprFuncNode::stringTime | ( | const MVTime & | dt,
|  | Int | prec )

static

## stringValue() [1/6]

String casacore::TableExprFuncNode::stringValue | ( | Bool | val,
|  | const String & | fmt,
|  | Int | width )

static

Convert a value to a string.

If fmt is empty, ostringstream is used. Otherwise the printf-like format is used. If possible, a double value is converted to radians if formatted as angle.

## stringValue() [2/6]

String casacore::TableExprFuncNode::stringValue | ( | const DComplex & | val,
|  | const String & | fmt,
|  | Int | width,
|  | Int | prec )

static

## stringValue() [3/6]

String casacore::TableExprFuncNode::stringValue | ( | const MVTime & | val,
|  | const String & | fmt,
|  | Int | width,
|  | const std::pair< int, int > & | mvFormat )

static

## stringValue() [4/6]

String casacore::TableExprFuncNode::stringValue | ( | const String & | val,
|  | const String & | fmt,
|  | Int | width )

static

## stringValue() [5/6]

String casacore::TableExprFuncNode::stringValue | ( | Double | val,
|  | const String & | fmt,
|  | Int | width,
|  | Int | prec,
|  | const std::pair< int, int > & | mvFormat,
|  | const Unit & | unit )

static

References casacore::TableExprNodeRep::unit().

## stringValue() [6/6]

String casacore::TableExprFuncNode::stringValue | ( | Int64 | val,
|  | const String & | fmt,
|  | Int | width )

static

## tryToConst()

void casacore::TableExprFuncNode::tryToConst | ( |  | ) |

private

Try if the function gives a constant result.

If so, set the expression type to Constant.

## Member Data Documentation

## argDataType_p

NodeDataType casacore::TableExprFuncNode::argDataType_p

private

Definition at line 470 of file ExprFuncNode.h.

Referenced by argDataType().

## funcType_p

FunctionType casacore::TableExprFuncNode::funcType_p

private

Definition at line 469 of file ExprFuncNode.h.

Referenced by funcType().

## scale_p

Double casacore::TableExprFuncNode::scale_p

private

Definition at line 471 of file ExprFuncNode.h.

Referenced by getScale().

## table_p

Table casacore::TableExprFuncNode::table_p

private

(needed for sqrt)

Definition at line 473 of file ExprFuncNode.h.

The documentation for this class was generated from the following file:

- tables/TaQL/ExprFuncNode.h